// Tree.h ... interface to binary search tree ADT
// Written by John Shepherd, March 2013

#ifndef BSTREE_H
#define BSTREE_H

typedef struct Node *Tree;

typedef char Key;
typedef Key Item; // item is just a key
#define key(it) (it)
#define cmp(k1,k2) ((k1) - (k2))
#define less(k1,k2) (comp(k1,k2) < 0)
#define eq(k1,k2) (comp(k1,k2) == 0)

// create an empty Tree
Tree newTree();
// free memory associated with Tree
void dropTree(Tree);
// display a Tree (sideways)
void showTree(Tree);

// insert a new value into a Tree
Tree TreeInsert(Tree, Item);
Tree insertAVL(Tree, Item);
Tree insertAtRoot(Tree, Item);
Tree insertRandom(Tree, Item);
// delete a value from a Tree
Tree TreeDelete(Tree, Key);
// check whether a value is in a Tree
int TreeFind(Tree, Key);
// compute depth of Tree
int TreeDepth(Tree);
// count #nodes in Tree
int TreeNumNodes(Tree);

Tree rotateR(Tree);
Tree rotateL(Tree);

Item *get_ith(Tree,int);
Tree partition(Tree,int);
Tree rebalance(Tree);

#endif
